package com.example.topadapter;

import static com.anythink.core.api.ATInitMediation.getStringFromMap;

import android.app.Activity;
import android.content.Context;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.widget.RelativeLayout;

import com.anythink.core.api.ATAdConst;
import com.anythink.core.api.ATBiddingListener;
import com.anythink.core.api.ATBiddingResult;
import com.anythink.core.api.MediationInitCallback;
import com.anythink.splashad.unitgroup.api.CustomSplashAdapter;
import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.AdViewListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;

import java.util.Map;

public class AlexCloooudSplashAdapter extends CustomSplashAdapter {

    boolean isC2SBidding = false;
    String slotId;
    private AdView splash;
    // 开屏广告视图父容器
    protected RelativeLayout mSplashRootContainer;
    @Override
    public void loadCustomNetworkAd(final Context context, Map<String, Object> serverExtra,
                                    Map<String, Object> localExtra) {
        if (!(context instanceof Activity)) {
            notifyATLoadFail("", "OpenAD: context must be activity");
            return;
        }
        if (!initAndVerifyRequestParams(context, serverExtra, localExtra)) {
            notifyATLoadFail("", "app_id or slot_id is empty!");
            return;
        }
        AlexCloooudInitManager.getInstance()
                .initSDK(context, serverExtra, new MediationInitCallback() {
                    @Override
                    public void onSuccess() {
                        if(!(context instanceof Activity)){
                            return;
                        }
                        // 开屏广告则初始化视图容器
                        mSplashRootContainer = new RelativeLayout(context.getApplicationContext());
                        int[] screenSizeDP = Util.getScreenSizeInDP(context);
                        AdRequestConfig requestConfig = new AdRequestConfig.Builder()
                                .AdType(AdConfig.AD_TYPE_SPLASH)
                                .requestTimeOutMillis(50000) //设置聚合SDK请求前超时时间，毫秒
                                .slotId(slotId) //广告id
                                .widthDp(screenSizeDP[0]) //请求图片宽度dp值
                                .heightDp(screenSizeDP[1]) //需要传广告展示的高度
                                .splashContainer(mSplashRootContainer) //设置开屏广告view容器
                                .build();
                        splash = new AdView((Activity) context, requestConfig);
                        splash.setListener(new AdViewListener() {
                            @Override
                            public void onAdClick() {
                                Log.e("CLOOOUD_POLY", "onAdClick: " );
                                if (mImpressionListener != null) {
                                    mImpressionListener.onSplashAdClicked();
                                }
                            }

                            @Override
                            public void onAdFailed(String msg) {
                                notifyATLoadFail( "9999", msg);
                            }

                            @Override
                            public void onAdReady(int price) {
                                if (isC2SBidding) {
                                    runOnNetworkRequestThread(new Runnable() {
                                        @Override
                                        public void run() {
                                            try {
                                                if (mBiddingListener != null) {
                                                    mBiddingListener.onC2SBiddingResultWithCache(
                                                            ATBiddingResult.success((double) price/100,
                                                                    System.currentTimeMillis() + "",
                                                                    null, ATAdConst.CURRENCY.RMB),
                                                            null);
                                                }
                                            } catch (Throwable e) {

                                            }
                                        }
                                    });
                                } else {
                                    if (mLoadListener != null) {
                                        mLoadListener.onAdCacheLoaded();
                                    }
                                }
                            }

                            @Override
                            public void onAdShow(CAdInfo cAdInfo) {
                                Log.e("CLOOOUD_POLY", "onAdShow: " );
                                if (mImpressionListener != null) {
                                    mImpressionListener.onSplashAdShow();
                                }
                            }

                            @Override
                            public void onAdDismissed(String s) {
                                Log.e("CLOOOUD_POLY", "onAdDismissed: " );
                                if (mImpressionListener != null) {
                                    mImpressionListener.onSplashAdDismiss();
                                }
                            }
                        });
                    }

                    @Override
                    public void onFail(String errorMsg) {
                        notifyATLoadFail("", errorMsg);
                    }
                });

    }

    @Override
    public boolean startBiddingRequest(Context context, Map<String, Object> serverExtra,
                                       Map<String, Object> localExtra,
                                       ATBiddingListener biddingListener) {
        isC2SBidding = true;
        loadCustomNetworkAd(context, serverExtra, localExtra);
        return true;
    }


    private boolean initAndVerifyRequestParams(Context context, Map<String, Object> serverExtra,
                                               Map<String, Object> localExtra) {
        String appId = getStringFromMap(serverExtra, "app_id");
        slotId = getStringFromMap(serverExtra, "slot_id");

        if (TextUtils.isEmpty(appId) || TextUtils.isEmpty(slotId)) {
            return false;
        }

        return true;
    }

    @Override
    public void destory() {

    }

    @Override
    public String getNetworkPlacementId() {
        return slotId;
    }

    @Override
    public String getNetworkSDKVersion() {
        return AlexCloooudInitManager.getInstance().getNetworkVersion();
    }

    @Override
    public String getNetworkName() {
        return AlexCloooudInitManager.getInstance().getNetworkName();
    }

    @Override
    public boolean isAdReady() {
        return true;
    }

    @Override
    public void show(Activity activity, ViewGroup container) {
        if (isAdReady()) {
            View splashView = mSplashRootContainer;
            if (splashView != null) {
                ViewParent vp = splashView.getParent();
                if (vp instanceof ViewGroup) {
                    ((ViewGroup) vp).removeView(splashView);
                }
            }
            container.addView(splashView);
            splash.showSplashAd();
        }
    }

    @Override
    public Map<String, Object> getNetworkInfoMap() {
        return null;
    }
}
