package com.example.topadapter;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;

import com.anythink.core.api.ATCustomVideo;
import com.anythink.nativead.api.ATNativePrepareExInfo;
import com.anythink.nativead.api.ATNativePrepareInfo;
import com.anythink.nativead.api.NativeAdInteractionType;
import com.anythink.nativead.unitgroup.api.CustomNativeAd;
import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.view.NativeAdsResponse;

import java.util.ArrayList;
import java.util.List;

public class AlexOpenADNativeAd extends CustomNativeAd {
    final String TAG = getClass().getSimpleName();
    NativeAdsResponse mFeedAd;
    Context mContext;
    boolean isDownloadStart = false;

    View expressFeedView;
    int mediaViewId;

    @Override
    public View getAdMediaView(Object... object) {
        if (mFeedAd != null && mFeedAd.getExpressAdView() != null) {
            expressFeedView = mFeedAd.getExpressAdView();
        }
        return expressFeedView;
    }

    @Override
    public boolean isNativeExpress() {
        if(mFeedAd != null && mFeedAd.isExpressAd()){
            return true;
        }
        return false;
    }

    public AlexOpenADNativeAd(Context context, NativeAdsResponse response) {
        mContext = context.getApplicationContext();
        mFeedAd = response;

        mediaViewId = 9527;
        try {
            int tempMediaViewId = mContext.getResources()
                    .getIdentifier("alex_OpenAD_mediaview_id", "id",
                            mContext.getPackageName());
            if (tempMediaViewId != 0) {
                mediaViewId = tempMediaViewId;
            }
        } catch (Throwable e) {

        }

//        setNetworkInfoMap(mFeedAd.getMediaExtraInfo());

        setAdData();
    }

    double videoProgress;

    public void setAdData() {
        setTitle(mFeedAd.getTitle());
        setDescriptionText(mFeedAd.getDesc());
        setAdFrom(mFeedAd.getAdSource().getName());
        setStarRating((double) mFeedAd.getAppScore());
//        setAppCommentNum(mFeedAd.);
        setIconImageUrl(mFeedAd.getImageUrl());
        setMainImageUrl(mFeedAd.getImageUrl());
        setImageUrlList(mFeedAd.getImageUrls());

        setCallToActionText("点击查看");

        setAdAppInfo(new AlexOpenADDownloadAppInfo(mFeedAd));

        int nativeAdInteractionType = NativeAdInteractionType.UNKNOW;
        if (mFeedAd.getInteractionType() == 4) {
            nativeAdInteractionType = NativeAdInteractionType.APP_DOWNLOAD_TYPE;
        }
        if (mFeedAd.getInteractionType() == 3) {
            nativeAdInteractionType = NativeAdInteractionType.DEEPLINK_TYPE;
        }
        if (mFeedAd.getInteractionType() == 2) {
            nativeAdInteractionType = NativeAdInteractionType.H5_TYPE;
        }
        setNativeInteractionType(nativeAdInteractionType);

        switch (mFeedAd.getSelfRenderAdMediaType()) {
            case NativeAdsResponse.NATIVE_AD_MEDIA_TYPE_VIDEO:
                mAdSourceType = NativeAdConst.VIDEO_TYPE;
                break;
            case NativeAdsResponse.NATIVE_AD_MEDIA_TYPE_IMAGE:
                mAdSourceType = NativeAdConst.IMAGE_TYPE;
                break;
        }
        mFeedAd.setNativeActionListener(new NativeAdsResponse.NativeActionListener() {
            @Override
            public void onAdClick() {
                notifyAdClicked();
            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                 notifyAdImpression();
            }

            @Override
            public void onError(String s) {

            }

            @Override
            public void onAdClose(String s) {
                Log.e("CLOOOUD_POLY", "onAdClose: " );
                notifyAdDislikeClick();

            }

            @Override
            public void onExpressRenderFail(String s) {

            }

            @Override
            public void onExpressRenderSuccess(View view, float v, float v1) {

            }

            @Override
            public void onExpressRenderTimeout() {

            }

            @Override
            public void onDislikeDialogShow() {

            }

            @Override
            public void onDownloadConfirmDialogDismissed() {

            }
        });

    }

    private void getChildView(List<View> childViews, View view) {
        if (view instanceof ViewGroup && view != mFeedAd.getExpressAdView()) {
            ViewGroup viewGroup = (ViewGroup) view;
            for (int i = 0; i < viewGroup.getChildCount(); i++) {
                View child = viewGroup.getChildAt(i);
                getChildView(childViews, child);
            }
        } else {
            if (view != mFeedAd.getExpressAdView()) {
                childViews.add(view);
            }
        }
    }

    @Override
    public void prepare(final View view, ATNativePrepareInfo nativePrepareInfo) {

        List<View> clickViewList = nativePrepareInfo.getClickViewList();

        if (clickViewList == null || clickViewList.size() == 0) {
            clickViewList = new ArrayList<>();
            getChildView(clickViewList, view);
        }

        if (view.getContext() instanceof Activity) {
             Activity activity = (Activity) view.getContext();
            registerView(view, (Activity) view.getContext(), nativePrepareInfo);
        } else {
            Log.w(TAG, TAG + " prepare fail," + view.getClass()
                    .getSimpleName() + " context must be Activity");
        }
    }

    private void registerView(View view, Activity context, ATNativePrepareInfo nativePrepareInfo) {
        View closeView = nativePrepareInfo.getCloseView();

        List<View> clickViewList = new ArrayList<>();

        List<View> clickViewLists = nativePrepareInfo.getClickViewList();
        if (clickViewLists != null && clickViewLists.size() > 0) {
            clickViewList.addAll(clickViewLists);
        } else {
            getChildView(clickViewList, view);
        }

        List<View> creativeViewList = new ArrayList<>();
        if (nativePrepareInfo instanceof ATNativePrepareExInfo) {
            List<View> creativeClickViewList = ((ATNativePrepareExInfo) nativePrepareInfo).getCreativeClickViewList();
            if (creativeClickViewList != null) {
                creativeViewList.addAll(creativeClickViewList);
            }
        }

        try {
            // 注册原生信息流广告可点击区域视图，建议为客户端单个原生广告位所有区域，在广告展现时调用
            mFeedAd.registerNativeClickableView(
                    (ViewGroup) view,
                    context,
                    (ViewGroup) view,
                    closeView);
        } catch (Throwable e) {
            e.printStackTrace();
        }
    }

    @Override
    public Bitmap getAdLogo() {
//        try {
//            if (mFeedAd != null) {
//                return mFeedAd.getLogoUrl();
//            }
//        } catch (Throwable e) {
//            e.printStackTrace();
//        }
        return null;
    }

    @Override
    public void clear(final View view) {
        unregisterView(view);
    }

    private void unregisterView(View view) {
        if (view == null) {
            return;
        }
        if (view instanceof ViewGroup) {
            if (mFeedAd != null && view == mFeedAd.getExpressAdView()) {
                return;
            }
            ViewGroup viewGroup = (ViewGroup) view;
            for (int i = 0; i < viewGroup.getChildCount(); i++) {
                View child = viewGroup.getChildAt(i);
                unregisterView(child);
            }
        } else {
            view.setOnClickListener(null);
            view.setClickable(false);
        }
    }


    @Override
    public double getVideoProgress() {
        return videoProgress;
    }

    @Override
    public ATCustomVideo getNativeCustomVideo() {
        return null;
    }

    @Override
    public void destroy() {
        try {
            if (mFeedAd != null) {
                mFeedAd.onDestroy();
            }
        } catch (Exception e) {

        }
        mContext = null;
        mFeedAd = null;
    }


}
